' ********************************************************
' *** ***
' *** Tiny-Reaktivlicht mit LDR und A/D-Wandler ***
' *** mit Watchdog-Energiesparmodus und Tagabschaltung ***
' *** ***
' ********************************************************

$regfile = "ATtiny13.DAT"
$crystal = 16000                                            'Frequenz des internen Oszillators
$hwstack = 2                                                'hardwarestack herabsetzen damit gengend variablen zur verfgung stehen

Config Adc = Single , Prescaler = Auto
Config Portb = &B00001000                                   'Pinb.3 auf 'Ausgang', Rest auf 'Eingang' schalten
Portb = 0                                                   'Ausgnge auf Low setzen
Stop Ac                                                     'Analog-Komparator abschalten, um Strom zu sparen

Wdtcr = &B11010011                                          'Watchdog definieren: 0.125 Sekunden, Interrupt auslsen, kein Reset
Enable Interrupts                                           'Interrupts freigeben

Const Schwelle = 50                                         'je grer der Schwellwert, desto unempfindlicher
Const Tagschwelle = 800                                     'Schwellwert fr Schlafmodus
Const Zwangsimpuls = 8                                      'LED-Impuls tagsber alle X Schlafyklen ( ca. 8 Sekunden)
Dim A As Byte                                               'Variablen definieren
Dim Tagzaehler As Byte
Dim Schlafzaehler As Byte
Dim Ldr As Integer                                          '0 = Dunkel, 1023 = Hell
Dim Alt As Integer
Dim Merker As Integer

Do
 Reset Watchdog
 Powerdown                                                  'prozessor bremsen da sonst lichtnderung nicht erkannt wird
 Start Adc                                                  'A/D-Wandler starten
 Ldr = Getadc(2)                                            'Helligkeitswert einlesen
 Stop Adc                                                   'A/D-Wandler zum Stromsparen wieder stoppen
 Merker = Ldr - Alt                                         'Unterschied zwischen letzter und aktueller Messung ermitteln
 Alt = Ldr                                                  'letzten LDR-Wert sichern
 If Merker > Schwelle Then
  Gosub Blinken                                             'Bei groer nderung Dunkel->Hell: Blinken
 End If
 If Ldr > Tagschwelle Then                                  'prfen ob helligkeit ber tagschwelle liegt
  If Tagzaehler < 255 Then                                  'int-variable geht nur bis 255
   Tagzaehler = Tagzaehler + 1
  End If
 Else
  Tagzaehler = 0                                            'wenn wieder dunkel tagzhler lschen
 End If
 If Tagzaehler > 200 Then
  Gosub Pause                                               'wenn mehr als x zyklen hell dann schlafmodus
 End If
Loop

Blinken:                                                    'LED blinken lassen
 For A = 0 To 10
  Portb.3 = 1
  Reset Watchdog
  Powerdown
  Portb.3 = 0
  Reset Watchdog
  Powerdown
 Next A
 Alt = 1023                                                 'Doppelauslsung verhindern
Return

Pause:
 Wdtcr = &B11110001                                         'Watchdog auf 8 Sekunden stellen
 Reset Watchdog
 Powerdown
 Wdtcr = &B11010011                                         'Watchdog wieder auf 0,125 Sekunden zurckstellen
 Schlafzaehler = Schlafzaehler + 1                          'merken wie oft Schlafmodus durchlaufen wurde
 If Schlafzaehler = Zwangsimpuls Then                       'als Funktionskontrolle tagsber LED auslsen
  Portb.3 = 1
  Reset Watchdog
  Powerdown
  Portb.3 = 0
  Schlafzaehler = 0
 End If
Return

End